import {CardGroup} from 'react-bootstrap';
import {useEffect, useState} from 'react';

import ProductCard from './ProductCard.js';

export default function FeaturedProducts() {

	const [previews, setPreviews] = useState([]);

	useEffect(() => {
		fetch(`${process.env.REACT_APP_API_BASE_URL}/products/`)
		.then(result => result.json())
		.then(data => {

			const numbers = [];
			const featured = [];

			const generateRandomNums = () => {
				let randomNum = Math.floor(Math.random() * data.length)

				if (numbers.indexOf(randomNum) === -1 ) {
					numbers.push(randomNum);
				}else{
					generateRandomNums();
				}
			}

			for (let i = 0; i < 5; i++) {
				generateRandomNums();

				featured.push( < ProductCard data = {data[numbers[i]]} key = {numbers[i]} />);
			}

			setPreviews(featured);

		})
	}, [])

	return(
		<>
			<h1 className = "text-center text-light mt-5 featured-title">Featured Products</h1>
			<CardGroup className = "justify-content-around">
				{previews}
			</CardGroup>
		</>
		)
}