import React from 'react';
import { Button } from 'react-bootstrap';
import Swal from 'sweetalert2';

const SaveEditButton = ({ editedValues, fetchData }) => {
  // console.log(editedValues)
  const { id, name, description, price, inventory } = editedValues

  const checkValues = () => {

  if (id === "" || name === "" || description === "" || inventory === "") {

  Swal.fire({
        title: "ERROR",
        icon: "error",
        text: "Please complete all fields."
      });

  } else {
    editProduct()
  }

}
  const editProduct = (event) => {

    if (inventory < 0 || inventory == "" || price <= 0 || price == "") {
      Swal.fire({
        title: "ERROR",
        icon: "error",
        text: "Invalid value input! Please enter a valid value."
      });
    } else if (inventory == 0) {

          Swal.fire({
            title: "Archived!",
            text: "Product has been archived.",
            icon: "success"
          });

          updateProduct();

          // deactivate product due to zero inventory
          fetch(`${process.env.REACT_APP_API_BASE_URL}/products/${id}/archive`, {
            method: "PUT",
            headers: {
              "Content-Type" : "application/json",
              Authorization: `Bearer ${localStorage.getItem('token')}`
            }
          })
          .then(result => result.json())
          .then(data => {fetchData();})

    } else {
      updateProduct();
    }
  };

  const updateProduct = () => {
    fetch(`${process.env.REACT_APP_API_BASE_URL}/products/${id}`, {
      method: "PUT",
      headers: {
        "Content-Type": "application/json",
        Authorization: `Bearer ${localStorage.getItem('token')}`
      },
      body: JSON.stringify({
        name: name,
        description: description,
        price: price,
        inventory: inventory
      })
    })
      .then(result => result.json())
      .then(data => {
        if (data) {
          Swal.fire({
            title: "Product updated!",
            icon: "success",
            text: "Product Successfully Updated!"
          });

          fetchData();
        } else {
          Swal.fire({
            title: "Product not updated!",
            icon: "error",
            text: "Please try again"
          });


        }

      })
      .catch(error => {
        console.error("Error updating product:", error);
        Swal.fire({
          title: "Error",
          icon: "error",
          text: "An unexpected error occurred while updating the product. Please try again."
        });
      });
  };

  return (
    <>
      <Button onClick={() => {checkValues()}} className="btn-submit nes-btn">
        Save
      </Button>
    </>
  );
};

export default SaveEditButton;
