import {Navigate} from "react-router-dom";
import {useContext, useEffect} from 'react';

import UserContext from '../UserContext.js';
import Swal from 'sweetalert2';

export default function Logout() {
	
	const {unSetUser} = useContext(UserContext);

	useEffect(() => {
		unSetUser();
		Swal.fire({
            title: "User successfully logged out!",
            icon: "success"
        })
	}, [])

	return (
		<Navigate to = "/login" />

		)
}